#!/bin/bash

installdir=`pwd`

which wget > /dev/null || (echo "Bitte installieren wget!"; exit 1)

if ! test -d popuser-utils
then
   echo "Bitte wechseln Sie in das pd-admin Installationsverzeichnis."
   exit
fi

install -g popuser -o popuser popuser-utils/rblcheck /home/popuser
install -g popuser -o popuser popuser-utils/spamfilter.pl /home/popuser 
install -g popuser -o popuser popuser-utils/safecat /home/popuser 

cd /home/popuser

for i in `find /home/popuser/ -name .qmail`; 
do 
   cp $i $i.bak
   echo "|/home/popuser/spamfilter.pl" >> $i.new
   cat $i >> $i.new
   mv $i.new $i
   chown popuser:popuser $i
done

echo "Installiere autoresponder"

mkdir /home/popuser/autorespond
chown popuser:popuser /home/popuser/autorespond
install -g popuser -o popuser $installdir/popuser-utils/autorespond /home/popuser/autorespond

echo "Installiere spamfilter"

cd /home/popuser
mkdir blacklists
chown popuser:popuser blacklists
mkdir whitelists
chown popuser:popuser whitelists
