#!/bin/bash
set -Ceuo pipefail

if [[ ${STDERR-} ]]; then
   exec 2>>"$STDERR"
   rm "$STDERR"
fi

nulenc=/usr/local/pd-admin2/bin/nulenc
$nulenc <<<'' >/dev/null
type lz4 >/dev/null

login=$1
cd /home
tar -Ilz4 -c "$login" | $nulenc
