#!/usr/bin/perl -w

$| = 1;

my $log = shift;

unless (defined $log and length $log) {
  die "Usage: $0 <file>\nPrints /var/log/<file> to standard output\n";
}

($log)  = $log =~ /(^[a-z0-9.-]+)$/ or die "Illegal logfile\n";
die "Illegal logfile\n" if ($log =~ /\.\./);
die "/var/log/$log does not exist" unless (-e "/var/log/$log");

open LOG, "/var/log/$log" or die "Can't open log /var/log/$log\n";
print <LOG>;
close LOG;
