#!/usr/local/pd-admin2/bin/perl 
#
#     configure-pma.pl
#     2004-09-14 stvo
#     $Id: configure-pma.pl,v 1.3 2004/10/15 07:58:22 testx Exp testx $
#

## use warnings;
## use strict;
use PDPASSWD;
use DBI;

my $rhostname = "";

my $MYPWF = 'xxxx';
if (-f '/opt/pdadmin/etc/mysql_rootpw.conf') {
   $MYPWF = '/opt/pdadmin/etc/mysql_rootpw.conf'
}
elsif (-f '/etc/admin/mysql_rootpw') {
   $MYPWF = '/etc/admin/mysql_rootpw';
}
else {
   die "MySQL root password not found\n";
}


if (-f '/opt/pdadmin/etc/pdadmin.conf') {
   do '/opt/pdadmin/etc/pdadmin.conf';
   $rhostname = $hostname;
}
elsif (-x '/etc/admin/config.pl') {
   do '/etc/admin/config.pl';
   $rhostname = $server_hostname;
}
else {
   die "neither pdadmin.conf nor config.pl found\n";
}
print "Kanonischer ServerName $rhostname fr phpMyAdmin\n";

sub fill (\$)
{
   my $s = shift;
   my $fillpasswd  
      = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'
      . '01234567890';
   while (length ($$s) < 8) {
      $$s .= substr ($fillpasswd, int (rand (length ($fillpasswd))), 1);
   }
}

sub main ()
{
   my $ctrusr = "pma";
   fill ($ctrusr);
   print "Richte MySQL-Benutzer '$ctrusr' als Control-User ein.\n";
   my $ctrpw = "";
   fill ($ctrpw);
   my $bfs = "";
   fill ($bfs);

   open (FI, "</opt/pdadmin/etc/mysql_rootpw.conf")
      or open (FI, "</etc/admin/mysql_rootpw")
      or die "cannot open password file\n";
   my $password = <FI>;
   chomp $password;
   close (FI);

#   print "MySQL root password: $password\n";

   my $dsn = "DBI:mysql:database=mysql;host=localhost;";
   my $dbh = DBI->connect($dsn, "root", $password);

#   print "control-password: $ctrpw\n";

   $dbh->do ("
      GRANT SELECT ON mysql.user TO $ctrusr\@localhost IDENTIFIED BY '$ctrpw'; 
      ");
   $dbh->do ("
      GRANT SELECT ON mysql.db TO $ctrusr\@localhost IDENTIFIED BY '$ctrpw'; 
      ");

   open (FI, "</usr/local/pd-admin2/htdocs/phpMyAdmin/config.default")
   or
   open (FI, "</usr/local/pd-admin2/htdocs/phpMyAdmin/config.default.php")
      or die "cannot open template (config.default)\n";
   my $templ_text;
   {
      local $/ = undef;
      $templ_text = <FI>;
   }
   close (FI);

   my $pmaau = 'http://' . $rhostname . '/phpMyAdmin/';

   $templ_text =~ s/\%CONTROLUSER\%/$ctrusr/;
   $templ_text =~ s/\%CONTROLPASS\%/$ctrpw/;
   $templ_text =~ s/\%BLOWFISH_SECRET\%/$bfs/;
   $templ_text =~ s/\%PMAABSOLUTEURI\%/$pmaau/;

   open (FO, ">/usr/local/pd-admin2/htdocs/phpMyAdmin/config.inc.php")
      or die "cannot overwrite config.inc.php: $!";
   print FO $templ_text;
   close (FO);

#
#     generate script
#
   open (FI,
         "</usr/local/pd-admin2/htdocs/phpMyAdmin/scripts/create_tables.sql.tmpl")
      or die "cannot read create_tables.sql.tmpl: $!";
   {
      local $/ = undef;
      $templ_text = <FI>;
   }
   $templ_text =~ s/\%CONTROLUSER\%/$ctrusr/;
   close (FI);
   open (FO, ">/usr/local/pd-admin2/htdocs/phpMyAdmin/scripts/create_tables.sql")
      or die "cannot (over)write create_tables.sql: $!";
   print FO $templ_text;
   close (FO);
   system ("cat /usr/local/pd-admin2/htdocs/phpMyAdmin/scripts/create_tables.sql | /usr/local/pd-admin2/bin/mysql -p`cat $MYPWF`");
   $dbh->do ("FLUSH PRIVILEGES")
      or die ("could not FLUSH PRIVILEGES: $!");
}

main ();
