#!/bin/bash
#
# Automatische Installtion von benötigten Paketen bei x64 Systemen
#
case $(cat /etc/*-release | sed -n 's/^NAME=*//p' | sed 's/["]//g' | sed 's/.*/\L&/') in
    "centos" | "centos linux" | "redhat" | "fedora" | "rocky linux") yum install wget patch groff-base make gcc gcc-c++ glibc-devel libstdc++-devel zlib-devel zlib.i686 libgcc.i686 ncurses-libs.i686 glibc.i686 ImageMagick rrdtool net-tools iptables-services libnsl libnsl.i686 libxcrypt libxcrypt.i686 screen unzip psmisc nmap unzip compat-openssl10 -y -q;;
    "ubuntu" | "debian" ) apt-get install g++ gcc imagemagick libtinfo5 lib32ncurses6 lib32stdc++6 lib32z1 libc6-dev-i386 make patch psmisc rrdtool groff wget -y;;
    "opensuse" | "opensuse leap" ) zypper install groff psmisc patch make gcc glibc-devel-32bit zlib-32bit libstdc++*-32bit libgcc*-32bit;;
    * ) echo "System nicht erkannt oder kein passenden Paketmanager gefunden."
    echo "Bitte installieren Sie folgende Pakete:"
    echo "wget patch groff make gcc gcc-c++ glibc-devel libstdc++-devel zlib-devel zlib.i686 libgcc.i686 ncurses-libs.i686 glibc.i686 ImageMagick rrdtool";;
esac
