#!/usr/local/pd-admin2/bin/perl -w

use strict;
use DBI;

#####
##### Read Configuration
#####

use vars qw($popuser_name $dsn $user $password $domainfile $apacherestart
            $popuser_id $popuser_gid $pop3_root);

do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't do it: $!";
my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

my $query = "select t1.login, t1.localpart, t3.name, t4.login ".
            "from pop3 as t1, vhosts as t2, domains as t3, users as t4 ".
            "where t1.vhost=t2.id and ".
            "t2.domain=t3.id and t3.owner=t4.id";

my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
my $rv  = $sth->execute or die "cannot execute query '$query'";

open ASSIGN, ">/var/qmail/users/assign" or die "/var/qmail/users/assign: $!";
flock ASSIGN, 2;

while (my ($username, $localpart, $subdomain, $loginid) = $sth->fetchrow_array) {

 print ASSIGN "=".$loginid."-".$subdomain."-".$localpart.":".$username.":".
              $popuser_id.":".$popuser_gid.":".$pop3_root.$subdomain."/".$username.":::\n";

}
$sth->finish;
print ASSIGN ".\n";
close ASSIGN;
system "/var/qmail/bin/qmail-newu"
