#!/bin/bash
set -Ceuo pipefail

if [[ ${STDERR-} ]]; then
   exec 2>>"$STDERR"
   rm "$STDERR"
fi

nulenc=/usr/local/pd-admin2/bin/nulenc
$nulenc <<<'' > /dev/null
type lz4 >/dev/null

tar -Ilz4 -C /home/popuser/popboxen -c "$@" -T /dev/null | $nulenc
