#!/bin/bash

shopt -s nullglob

month=`cat /opt/pdadmin/etc/delete_logs_after.conf 2>/dev/null`
if [ "$month" == "" ]; then
   month=1
fi
touch --date="$month month ago" /opt/pdadmin/tmp/.timestamp_rm_logs
for i in /home/*/logs/archive/*.gz /home/*/logs/archive/*.lz4; do
   if test /opt/pdadmin/tmp/.timestamp_rm_logs -nt "$i"; then
       rm "$i"
   fi
done

touch --date="7 days ago" /opt/pdadmin/tmp/.timestamp_rm_logs
for i in /home/errorlogs/*/*.gz /home/errorlogs/*/*.lz4; do
   if test /opt/pdadmin/tmp/.timestamp_rm_logs -nt "$i"; then
       rm "$i"
   fi
done
