#!/usr/bin/perl -w

$| = 1;

my $log = shift;

unless (defined $log and length $log) {
  die "Usage: $0 <file>\nPrints /usr/local/pd-admin2/logs/<file> to standard output\n";
}

($log)  = $log =~ /(^[_a-z0-9.-]+)$/ or die "Illegal logfile\n";
die "Illegal logfile\n" if ($log =~ /\.\./);
die "/var/log/$log does not exist" unless (-e "/usr/local/pd-admin2/logs/$log");

open LOG, "/usr/local/pd-admin2/logs/$log" or die "Can't open log /usr/local/pd-admin2/logs/$log\n";
print <LOG>;
close LOG;
