#!/usr/local/pd-admin2/bin/perl

use strict;
use Mail::SRS;

$| = 1;

open S, "/opt/pdadmin/etc/srs.conf" or die $!;
my $me = <S>;
my $secret = <S>;
chomp $secret;
chomp $me;
close S;

my $sender = $ENV{EXT2} . "@" . $me;
$sender =~ s/^srs-//;

my $s = new Mail::SRS(Secret => $secret, MaxAge => 10, HashLength => 8);
my $a = $s->reverse($sender) || die "SRS encoding failed";

$ENV{SENDER} = $a;
$ENV{NEWSENDER} = $a;
$ENV{RPLINE} = "Return-Path: $a\n";

print STDERR "Bounce SRS $sender -> $a\n";

exit unless (defined $a);

exec '/var/qmail/bin/qmail-inject', '-f', '', $a and die $!;
