#!/usr/local/pd-admin2/bin/perl

use strict;
use Mail::SRS;

unless (defined $ENV{SENDER} and length $ENV{SENDER}){
    exec '/var/qmail/bin/forward', @ARGV or die $!;
}

$| = 1;

open S, "/opt/pdadmin/etc/srs.conf" or die $!;
my $me = <S>;
my $secret = <S>;
chomp $secret;
chomp $me;
close S;


my $s = new Mail::SRS(Secret => $secret, MaxAge => 10, HashLength => 8);
my $a = $s->forward($ENV{SENDER}, '') || die "SRS encoding failed";

$a = "srs-$a$me";

$ENV{SENDER} = $a;
$ENV{NEWSENDER} = $a;
$ENV{RPLINE} = "Return-Path: $a\n";

exec '/var/qmail/bin/forward', @ARGV or die $!;
