#!/bin/bash

EXCLUDE_OLD=$(grep '^exclude=' /etc/yum.conf | sed s,^exclude=,,)

for i in $(echo $EXCLUDE $* | sort -u) ; do
   if [ "$EXCLUDE" = "" ]; then
      EXCLUDE="$i"
    else
      EXCLUDE="$EXCLUDE $i"
    fi
done

if [ "$EXCLUDE" != "" ]; then
   sed -i '/^exclude=/d' /etc/yum.conf
   echo "exclude=$EXCLUDE"
   echo "exclude=$EXCLUDE" >> /etc/yum.conf
fi
