#!/usr/local/pd-admin2/bin/perl -w

use CGI ':standard';

my $file         = param 'file';
my $lang         = param 'lang';

die "CRACK" unless (defined $lang and $lang =~ /^[a-z]{2}$/);

unless (-d "/opt/pdadmin/www/html/administrator/help/$lang") {
   $lang = 'de';
}

$file ||= '';

$file  =~ s/\.html$//;
$file .=  '.html';
my $skin_dir = '/opt/pdadmin/html';

my $help;
if ($file =~ /^[a-z0-9.-]+$/) {
   my $help_file;
   if (-e "$skin_dir/administrator/help/$lang/$file") {
       $help_file = "$skin_dir/administrator/help/$lang/$file"
   } elsif (-e "/opt/pdadmin/www/html/administrator/help/$lang/$file") {
       $help_file = "/opt/pdadmin/www/html/administrator/help/$lang/$file"
   } elsif (-e "$skin_dir/administrator/help/$lang/index.html") {
       $help_file = "$skin_dir/administrator/help/$lang/index.html"
   } elsif (-e "/opt/pdadmin/www/html/administrator/help/$lang/index.html") {
       $help_file = "/opt/pdadmin/www/html/administrator/help/$lang/index.html";
   } else {
       $help  = 'Zu diesem Thema gibt es noch keine Hilfe.';
   }

   if (open HELP, $help_file) {
      $help = join '', <HELP>;
      close HELP;
   } else {
       $help  = 'Zu diesem Thema gibt es noch keine Hilfe.';
   }
} else {
   $help = 'Ungueltiger Filename';
}
   
print header, $help;
exit
