#!/usr/local/pd-admin2/bin/perl -w

use CGI ':standard';
use strict;

my $file = param 'file';
my $lang = param 'lang';

die "CRACK" unless (defined $lang and $lang =~ /^[a-z]{2}$/);

unless (-d "/opt/pdadmin/www/customer/html/help/$lang") {
   $lang = 'de';
}

my $help;
if ($file =~ /^[a-z0-9.]+$/) {
   if (open FILE, "/opt/pdadmin/www/customer/html/help/$lang/$file") {
      $help  = join '', <FILE>;
      close FILE;
   } else {
      if  (open FILE, "/opt/pdadmin/www/customer/html/help/$lang/index.html") {
         $help  = join '', <FILE>;
         close FILE;
      } else {
         $help  = 'Zu diesem Thema gibt es noch keine Hilfe.' . "/opt/pdadmin/www/customer/html/help/$lang/index.html: $!";
      }
   }
} else {
   $help     = 'Dateiname enthlt ungltige Zeichen: Zugriff wurde geloggt!';
}

print header, $help;
exit
