#!/bin/bash
#
# 2005-01-04 stvo: download everything in advance
#
# $Id: prefetch.sh,v 1.8 2016/10/26 13:37:22 testx Exp testx $
#

set +e

type -p wget > /dev/null || {
   echo "Bitte installieren wget!"; 
   exit
}
US=/usr/src
function prefetch ()
{
   pushd $US
   wget --tries=3 -nc -i - <<EOT
http://download.pd-admin.de/qmail-1.03.tar.gz
http://download.pd-admin.de/tp/daemontools-0.76.tar.gz
http://download.pd-admin.de/daemontools-0.76.errno.patch
http://download.pd-admin.de/tp/ucspi-tcp-0.88.tar.gz
http://download.pd-admin.de/tp/ucspi-tcp-0.88-ipv6.diff19
http://download.pd-admin.de/qmail-1.03.errno.patch
http://download.pd-admin.de/qmail-queue.patch
http://download.pd-admin.de/qmail-smtpd-auth-0.31.tar.gz
http://download.pd-admin.de/tp/fastforward-0.51.tar.gz
http://download.pd-admin.de/ezmlm-0.53.tar.gz
http://download.pd-admin.de/ezmlm-0.53-errno.patch
http://download.pd-admin.de/service3.tar.gz
http://download.pd-admin.de/service3r.tar.gz
http://download.pd-admin.de/qmail-1.03.dns.patch
http://download.pd-admin.de/ezmlm-idx-5.1.1.tar.gz
http://download.pd-admin.de/qmail-spp-0.42.tar.gz
http://download.pd-admin.de/qmail-checkuser3.patch
http://download.pd-admin.de/qmail-xot.patch
http://download.pd-admin.de/tp/doublebounce-trim.patch
http://download.pd-admin.de/service-dovecot22.tgz
http://download.pd-admin.de/tcpserver-limits-2006-01-26-ipv6.diff
EOT
   RV=$?
   if [ $RV -ne 0 ]; then
      echo "file prefetching failed, try again later"
      exit 7
   fi
   popd
}
prefetch
set -e
