#!/bin/sh
#
#	configure-apache.inc
#  $Id: configure-apache.inc,v 1.3 2022/09/26 15:55:13 testx Exp testx $ 
# 

INST=/usr/local/pd-admin2

echo ""
echo "Konfiguration des Webservers"
echo "----------------------------"
echo ""

SERVERNAME=`hostname -f`

function ask_for_hostname()
{
   echo -n "Hostname [$SERVERNAME]: "
   read ans
   if [ "$ans" != "" ]; then
     SERVERNAME=$ans
   fi
}
if unattended_install; then
   :
else
   ask_for_hostname
fi

echo ""
echo "verwende $SERVERNAME"
echo ""

IP=`/usr/local/pd-admin2/bin/perl -MIO::Socket -e "print inet_ntoa scalar gethostbyname '$SERVERNAME'" 2>/dev/null`

function ask_for_ip_adress()
{
   while [ "$IPADD" == "" ]; do
      echo -n "IP-Adresse [$IP]: "
      read IPADD
           if [ "$IPADD" == "" ]; then
              IPADD=$IP
           fi
   done
}
if unattended_install; then
   IPADD=$IP
else
   ask_for_ip_adress
fi

echo ""
echo "verwende IPADD = <$IPADD>"
echo ""

if [ ! -e $INST/httpd-2.4/conf/httpd24.conf-template ]; then
   cp $HERE/templates/httpd24.conf-template $INST/httpd-2.4/conf/
fi
