#!/usr/local/pd-admin2/bin/perl 
#
#     configure-ci.pl
#     2004-10-06 stvo
#     $Id: configure-ci.pl,v 1.1 2004/10/06 09:29:38 testx Exp testx $
#

## use warnings;
## use strict;

if (-f '/opt/pdadmin/etc/pdadmin.conf') {
   do '/opt/pdadmin/etc/pdadmin.conf';
}
elsif (-x '/etc/admin/config.pl') {
   do '/etc/admin/config.pl';
}
else {
   die "neither pdadmin.conf nor config.pl found\n";
}

sub main ()
{
   my $mysql_passwd = $password;
   my $mysql_socket = '/usr/local/pd-admin2/tmp/mysql.sock';

   my ($login, $pass, $popuser_uid, $popuser_gid)
      = getpwnam ('popuser')
      or die "no user popuser in passwd file\n";

   open (FI, "</usr/local/pd-admin2/etc/authmysqlrc.tmpl")
      or die "cannot open template (authmysqlrc.tmpl)\n";
   my $templ_text;
   {
      local $/ = undef;
      $templ_text = <FI>;
   }
   close (FI);

   $templ_text =~ s/\%MYSQL_PASSWD\%/$mysql_passwd/;
   $templ_text =~ s/\%MYSQL_SOCKET\%/$mysql_socket/;
   $templ_text =~ s/\%POPUSER_UID\%/$popuser_uid/;
   $templ_text =~ s/\%POPUSER_GID\%/$popuser_gid/;

   open (FO, ">/usr/local/pd-admin2/etc/authmysqlrc")
      or die "cannot overwrite authmysqlrc: $!";
   print FO $templ_text;
   close (FO),
}

main ();
